echo off

set BUILD_TOOLS=0

set BUILD_WIN32=1
set BUILD_LEGACY=0
set BUILD_WIN64=0


rem set FPC_VER=3.0.0rc1
set FPC_VER=2.6.4

set MODNAME=_test019

set COLDPATH=%PATH%

set PATH=c:\FPC\%FPC_VER%\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

mkdir ..\..\..\tmp\
mkdir ..\..\..\tmp\main
mkdir ..\..\..\tmp\tools

del /Q .\*.ppu
del /Q .\*.o

if "%BUILD_TOOLS%" == "1" goto tooyes
goto tooend
:tooyes
fpc incbuild.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc brutalstrip.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc extractdwrflnfo.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc finalizedwrflnfo.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
:tooend

if "%BUILD_WIN32%" == "1" goto w32yes
goto w32end
:w32yes

mkdir ..\..\..\tmp\%MODNAME%\
rem some units are used by both the mother module and the game modules,
rem but with different conditionals. The compiler doesn't know that,
rem  it finds an existing *.ppu and doesn't recompile it. Then things go boom.
del /Q ..\..\..\tmp\%MODNAME%\chelinfo*
rem del /Q  ..\..\..\tmp\%MODNAME%\*
del /Q ..\%MODNAME%.dll
del /Q ..\%MODNAME%_nosse2.dll
rem -Co -Cr -Sa -Ct
rem set COPTS= -Cr -Sa -Sc -gw -OppentiumM -O2 -dcgemodule -dcge -dnotlaz -dfixedmath -Mobjfpc -Sh -Rintel -Fi..\..\chentrah\src -Fu..\..\chentrah\src
set COPTS= -Cr -Sa -Sc -gw -O2 -Xi -XX -ve -dcgemodule -dcge -dnotlaz -dfixedmath -Mobjfpc -Sh -Rintel -Fi..\..\chentrah\src -Fu..\..\chentrah\src
rem set COPTS= -OoPeepHole -Ooasmcse -OoUncertain -OoRegVar -OpPentium4 -Sc -O3 -gw -dcgemodule -dcge -dnotlaz -Mobjfpc -Sh -Rintel -Fi../../chentrah/src -Fu../../chentrah/src
fpc _chentrah_module.lpr -Twin32 -CfSSE2 %COPTS%  -FU..\..\..\tmp\%MODNAME%\ -Fu..\..\..\tmp\%MODNAME%\
if errorlevel 1 goto err
incbuild build.h
brutalstrip _chentrah_module.dll
upx -9 --force _chentrah_module.dll
finalizedwrflnfo _chentrah_module.dll
move _chentrah_module.dll ..\%MODNAME%.dll
move _chentrah_module.zd2 ..\%MODNAME%.zd2

if "%BUILD_LEGACY%" == "1" goto legacyyes
goto w32end
:legacyyes

set PATH=c:\FPC\2.6.4\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

rem A special version of the module dll for those ancient CPUs without SSE2 support like AMD Sempron
mkdir ..\..\..\tmp\%MODNAME%\2\
del /Q ..\..\..\tmp\%MODNAME%\2\chelinfo*
fpc _chentrah_module.lpr -Twin32 %COPTS% -FU..\..\..\tmp\%MODNAME%\2\ -Fu..\..\..\tmp\%MODNAME%\2\
if errorlevel 1 goto err
incbuild build.h
brutalstrip _chentrah_module.dll
upx -9 --force _chentrah_module.dll
finalizedwrflnfo _chentrah_module.dll
move _chentrah_module.dll ..\%MODNAME%_legacy.dll
move _chentrah_module.zd2 ..\%MODNAME%_legacy.zd2

:w32end





if "%BUILD_WIN64%" == "1" goto w64yes
goto w64end
:w64yes

set PATH=c:\FPC\%FPC_VER%\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

mkdir ..\..\..\tmp\%MODNAME%-x86_64\
rem some units are used by both the mother module and the game modules,
rem but with different conditionals. The compiler doesn't know that,
rem  it finds an existing *.ppu and doesn't recompile it. Then things go boom.
del /Q ..\..\..\tmp\%MODNAME%-x86_64\chelinfo*
rem del /Q  ..\..\..\tmp\%MODNAME%-x86_64\*
del /Q ..\%MODNAME%-x86_64.dll
rem -Co -Cr -Sa -Ct
set COPTS=-Co -Cr -Ct -Sa -gw -CfSSE64 -Opathlon64 -O2 -Sc -dcgemodule -dcge -dnotlaz -dfixedmath -Mobjfpc -Sh -Rintel -Fi..\..\chentrah\src -Fu..\..\chentrah\src
ppcrossx64 _chentrah_module.lpr -Twin64 %COPTS%  -FU..\..\..\tmp\%MODNAME%-x86_64\ -Fu..\..\..\tmp\%MODNAME%-x86_64\
if errorlevel 1 goto err
incbuild build.h
x86_64-win64-strip ..\..\..\tmp\%MODNAME%-x86_64\_chentrah_module.dll
upx -9 --force ..\..\..\tmp\%MODNAME%-x86_64\_chentrah_module.dll
move _chentrah_module.dll ..\%MODNAME%-x86_64.dll


:w64end




:err
