echo off

set BUILTIN=bryed3dev

rem set to 1 to recompile accompanying tools (incbuild, brutalstrip and the like)
set COMPILE_TOOLS=0

rem Legacy is
set COMPILE_LEGACY=0
set COMPILE_WIN32=1
set COMPILE_WIN64=0
set COMPILE_DEBUG=1

set PACK_RELEASE=0
set RELEASE_DIR=..\..\..\tmp\chentrah\
set RTDIR=..\..\..\

rem set FPC_VER=3.0.0rc1
set FPC_VER=2.6.4
rem The legacy version uses 2.6.4 as later versions do not support Windows 98!

set COLDPATH=%PATH%

set PATH=c:\FPC\%FPC_VER%\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

set CODE_OPTIONS=-O2 -OpPentiumM -CfSSE2
rem -OpPentiumM -O2
rem set CGE_OPTIONS= -Sa -gw2 -gl -Xi -XX -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_OPTIONS%
set CGE_OPTIONS= -Sa -gl -gw2 -Xi -XX -vv -ve -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_OPTIONS%
set CGE64_OPTIONS= -Sa -gl -Xi -XX -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel
set CODE64_OPTIONS=-Co -Cr -Ct -Sa -CfSSE64 -Opathlon64 -O2 -Sc
set CODE_LEGACY_OPTIONS=-O2 -OpPentiumM
rem -OpPentiumM -O2
rem set CGE_OPTIONS= -Sa -gw2 -gl -Xi -XX -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_OPTIONS%
set CGE_LEGACY_OPTIONS= -Sa -gl -gw2 -Xi -XX -vv -ve -dcge -dnotlaz -dcge_rc_directly -Mobjfpc -Sh -Sc -Rintel %CODE_LEGACY_OPTIONS%


rem set CGE_PATHS=-FE..\..\..\ -Fi..\..\%BUILTIN%\src\ -Fu..\..\%BUILTIN%\src\

set VY_PATHS=-Fu..\..\..\3rdparty\Imaging\Source\  -Fu..\..\..\3rdparty\Imaging\Source\ZLib\  -Fi..\..\..\3rdparty\Imaging\Source\ -Fu..\..\..\3rdparty\Imaging\Source\JpegLib\

mkdir ..\..\..\tmp\
mkdir ..\..\..\tmp\main
mkdir ..\..\..\tmp\main-debug
mkdir ..\..\..\tmp\tools

del /Q .\*.ppu
del /Q .\*.o

bin2obj -o cl_builtin_font.inc -c builtin_font font.png
bin2obj -o cl_console_font.inc -c iim_console consolefont.png
bin2obj -o cl_bgimg_error.inc -c error_bg_img cl_background_error.png
bin2obj -o cl_cursor_cyan.inc -c cursor_cyan_img cl_cursor_normal.png
bin2obj -o cl_cursor_yellow.inc -c cursor_yellow_img cl_cursor_error.png
bin2obj -o cl_cursor_hourglass.inc -c cursor_hourglass_img cl_cursor_hourglass.png
bin2obj -o cl_minifont.inc -c minifont_img cl_minifont.png
bin2obj -o cl_errbutton.inc -c errbutton_img cl_errbutton.png
bin2obj -o cl_erricon.inc -c erricon_img cl_erricon.png

if "%COMPILE_TOOLS%" == "1" goto tooyes
goto tooend
:tooyes
fpc incbuild.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc brutalstrip.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc extractdwrflnfo.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
fpc finalizedwrflnfo.pp -FE..\..\..\bin\ -FU..\..\..\tmp\tools
:tooend



if "%COMPILE_WIN64%" == "1" goto w64yes
goto w64end
:w64yes


if "%COMPILE_DEBUG%" == "1" goto dbug64yes
goto dbug64end
:dbug64yes
mkdir ..\..\..\tmp\main-x86_64-debug\
del /Q ..\..\..\chentrah-debug-x86_64.exe

rem fpc chentrah.lpr -ddebug_build %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main-x86_64-debug\ %CGE_PATHS% %VY_PATHS%
ppcrossx64 -gl	-ddebug_build chentrah.lpr -Twin64 %CGE64_OPTIONS% %CODE64_OPTIONS% %VY_PATHS% -FE..\..\..\tmp\main-x86_64-debug\ -FU..\..\..\tmp\main-x86_64-debug\ -Fu..\..\..\tmp\main-x86_64-debug\
if errorlevel 1 goto err
move ..\..\..\tmp\main-x86_64-debug\chentrah.exe  ..\..\..\chentrah-debug-x86_64.exe
rem x86_64-win64-strip ..\..\..\chentrah-debug-x86_64.exe
rem upx -9 --force ..\..\..\chentrah-debug-x86_64.exe

:dbug64end


del /Q ..\..\..\chentrah-x86_64.exe
mkdir ..\..\..\tmp\main-x86_64\
rem fpc chentrah.lpr %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main\ %CGE_PATHS% %VY_PATHS%
ppcrossx64 -dLCL -gl chentrah.lpr -Twin64 %CGE64_OPTIONS% %CODE64_OPTIONS% %VY_PATHS% -FE..\..\..\tmp\main-x86_64\ -FU..\..\..\tmp\main-x86_64\ -Fu..\..\..\tmp\main-x86_64\
if errorlevel 1 goto err
incbuild build.h
move ..\..\..\tmp\main-x86_64\chentrah.exe ..\..\..\chentrah-x86_64.exe
rem x86_64-win64-strip ..\..\..\chentrah-x86_64.exe
rem upx -9 --force ..\..\..\chentrah-x86_64.exe

:w64end




if "%COMPILE_LEGACY%" == "1" goto legacyyes
goto legacyend
:legacyyes

set PATH=c:\FPC\2.6.4\bin\i386-win32\;..\..\..\bin\;%COLDPATH%



if "%COMPILE_DEBUG%" == "1" goto dbuglegyes
goto dbuglegend
:dbuglegyes
mkdir ..\..\..\tmp\legacy-debug\
del /Q ..\..\..\chentrah-legacy-debug.exe
fpc chentrah.lpr -ddebug_build -dche_legacy %CGE_LEGACY_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\legacy-debug\ -FE..\..\..\tmp\legacy-debug\ %CGE_PATHS% %VY_PATHS%
if errorlevel 1 goto err
move ..\..\..\tmp\legacy-debug\chentrah.exe  ..\..\..\chentrah-legacy-debug.exe
extractdwrflnfo ..\..\..\chentrah-legacy-debug.exe
strip ..\..\..\chentrah-legacy-debug.exe
upx -9 --force ..\..\..\chentrah-legacy-debug.exe
finalizedwrflnfo ..\..\..\chentrah-legacy-debug.exe
:dbuglegend


mkdir ..\..\..\tmp\legacy\
del /Q ..\..\..\chentrah-legacy.exe
fpc chentrah.lpr -dche_legacy %CGE_LEGACY_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\legacy\  -FE..\..\..\tmp\legacy\ %VY_PATHS%
if errorlevel 1 goto err
incbuild build.h
move ..\..\..\tmp\legacy\chentrah.exe  ..\..\..\chentrah-legacy.exe
extractdwrflnfo ..\..\..\chentrah-legacy.exe
rem brutalstrip ..\..\..\chentrah.exe
strip ..\..\..\chentrah-legacy.exe
rem UPX is mandatory, it fixes the executable broken by brutalstrip.
rem  (how does all of this work I have no slightest clue.
rem    I guess I missed some vital detail when I was writing brutalstrip)
upx -9 --force ..\..\..\chentrah-legacy.exe
finalizedwrflnfo ..\..\..\chentrah-legacy.exe
rem move ..\..\..\chentrah.zd2 ..\bin\

:legacyend




if "%COMPILE_WIN32%" == "1" goto w32yes
goto w32end
:w32yes

set PATH=c:\FPC\%FPC_VER%\bin\i386-win32\;..\..\..\bin\;%COLDPATH%

if "%COMPILE_DEBUG%" == "1" goto dbugyes
goto dbugend
:dbugyes

del /Q ..\..\..\tmp\main-debug\*.ppu
del /Q ..\..\..\tmp\main-debug\*.o
del /Q ..\..\..\chentrah-debug.exe
ppc386 chentrah.lpr -ddebug_build %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main-debug\ -FE..\..\..\ %VY_PATHS%
if errorlevel 1 goto err
move ..\..\..\chentrah.exe  ..\..\..\chentrah-debug.exe
extractdwrflnfo ..\..\..\chentrah-debug.exe
strip ..\..\..\chentrah-debug.exe
upx -9 --force ..\..\..\chentrah-debug.exe
finalizedwrflnfo ..\..\..\chentrah-debug.exe
:dbugend


del /Q ..\..\..\tmp\main\*.ppu
del /Q ..\..\..\tmp\main\*.o

del /Q ..\..\..\chentrah.exe
fpc chentrah.lpr %CGE_OPTIONS% -CX -Twin32 -FU..\..\..\tmp\main\ -FE..\..\..\ %VY_PATHS%
if errorlevel 1 goto err
incbuild build.h
extractdwrflnfo ..\..\..\chentrah.exe
rem brutalstrip ..\..\..\chentrah.exe
strip ..\..\..\chentrah.exe
rem UPX is mandatory, it fixes the executable broken by brutalstrip.
rem  (how does all of this work I have no slightest clue.
rem    I guess I missed some vital detail when I was writing brutalstrip)
upx -9 --force ..\..\..\chentrah.exe
finalizedwrflnfo ..\..\..\chentrah.exe
rem move ..\..\..\chentrah.zd2 ..\bin\

:w32end





:err
