cd ../../${MODNAME}/src

#Must be installed in Wine
FPC_VER=2.6.0

#Paths must NOT contain spaces.
DRIVE_C=/home/${USER}/.wine/drive_c
COMPPATH=/FPC/${FPC_VER}/bin/i386-win32


#these options cause a crash:
#  -OoTailRec -OoLoopUnRoll
CODE_OPTIONS="-OpPentiumM -O3 -OoUncertain -OoRegVar -OoPeepHole -Ooasmcse"

#  if [ $COMPILE_VAMPYRE == 1 ]
#  then
    VY_PATHS="-Fu../../../3rdparty/Imaging/Source/  -Fu../../../3rdparty/Imaging/Source/ZLib/  -Fi../../../3rdparty/Imaging/Source/ -Fu../../../3rdparty/Imaging/Source/JpegLib/"
#  else
#    VY_PATHS="-Fu../../../3rdparty/bin/lin/ -Fu../../../3rdparty/bin/win/"
#  fi

#if [ $COMPILE_VAMPYRE == 1 ]
#then
  rm --recursive --verbose --one-file-system /tmp/.chentrah/main/*
  rm --recursive --verbose --one-file-system ../../../tmp/main/*
#fi

mkdir /tmp/.chentrah
mkdir /tmp/.chentrah/main
mkdir /tmp/.chentrah/tools

# -CX (Create also smartlinked library)
#   saves about 100Kb on the Linux executable size
#   but by some reason prevents the Dwarf2 debug info from being generated
  CGE_OPTIONS="-CfSSE -gw2 -Xi -XX -dcge -dnotlaz -Mdelphi -Sh -Sc -Rintel ${CODE_OPTIONS}"
  CGE_PATHS="-Fi../../chentrah/src/ -Fi../../${MODNAME}/src/ -Fu../../${MODNAME}/src/"

if [ $BUILD_TOOLS == 1 ]
then
  fpc ../../chentrah/src/extractdwrflnfo.pp -FE../../../bin/ -FU/tmp/.chentrah/
  fpc ../../chentrah/src/finalizedwrflnfo.pp -FE../../../bin/ -FU/tmp/.chentrah/
  fpc ../../chentrah/src/brutalstrip.pp -FE../../../bin/ -FU/tmp/.chentrah/
  fpc ../../chentrah/src/incbuild.dpr -FE../../../bin/ -FU/tmp/.chentrah/
fi

if [ $BUILD_WIN32 == 1 ]
then
  mkdir ../../../tmp/${MODNAME}/
  #some units are used by both the mother module and the game modules,
  #  but with different conditionals. The compiler doesn't know that,
  #  it finds an existing *.ppu and doesn't recompile it. Then things go boom.
  rm ../../../tmp/${MODNAME}/chelinfo*
  #rm ../../../tmp/${MODNAME}/*
  rm ../${MODNAME}.dll
  rm ../${MODNAME}_nosse2.dll
  COPTS="-OoPeepHole -Ooasmcse -OoUncertain -OoRegVar -OpPentium4 -Sc -O3 -gw -dcgemodule -dcge -dnotlaz -Mobjfpc -Sh -Rintel -Fi../../chentrah/src -Fu../../chentrah/src"
  wine ${DRIVE_C}/${COMPPATH}/ppc386.exe _chentrah_module.lpr -Twin32 -CfSSE2 ${COPTS}  -FU../../../tmp/${MODNAME}/ -Fu../../../tmp/${MODNAME}/
  ../../../bin/incbuild build.h
  ../../../bin/brutalstrip _chentrah_module.dll
  upx -9 --force _chentrah_module.dll
  ../../../bin/finalizedwrflnfo _chentrah_module.dll
  mv _chentrah_module.dll ../${MODNAME}.dll
  mv _chentrah_module.zd2 ../${MODNAME}.zd2
  if  [ $BUILD_NOSSE2 == 1 ]
  then
    mkdir ../../../tmp/${MODNAME}/2/
    rm ../../../tmp/${MODNAME}/2/chelinfo*
    wine ${DRIVE_C}/${COMPPATH}/ppc386.exe _chentrah_module.lpr -Twin32 ${COPTS}  -FU../../../tmp/${MODNAME}/2/ -Fu../../../tmp/${MODNAME}/2/
    ../../../bin/incbuild build.h
    ../../../bin/brutalstrip _chentrah_module.dll
    upx -9 --force _chentrah_module.dll
    ../../../bin/finalizedwrflnfo _chentrah_module.dll
    mv _chentrah_module.dll ../${MODNAME}_nosse2.dll
    mv _chentrah_module.zd2 ../${MODNAME}_nosse2.zd2
  fi
  if [ $BUILD_BUILTIN == 1 ]
  then
    rm ../../../${MODNAME}.exe
    wine ${DRIVE_C}${COMPPATH}/ppc386.exe ../../chentrah/src/chentrah.lpr ${CGE_OPTIONS} -CX -CfSSE2 -Twin32 -FE../../../tmp/ -dbuildmein -FU../../../tmp/main/ ${CGE_PATHS} ${VY_PATHS}
    ../../../bin/incbuild build.h
    ../../../bin/brutalstrip ../../../tmp/chentrah.exe
    #UPX is mandatory, it fixes the executable broken by brutalstrip.
    #  (I have no slightest clue how this works.
    #    I guess I've missed some vital detail when I was writing brutalstrip)
    wine ${DRIVE_C}${COMPPATH}/upx.exe -9 --force ../../../tmp/chentrah.exe
    ../../../bin/finalizedwrflnfo ../../../tmp/chentrah.exe
    mv ../../../tmp/chentrah.exe ../../../${MODNAME}.exe
    mv ../../../tmp/chentrah.zd2 ../../chentrah/bin/${MODNAME}.zd2

#    if [ $COMPILE_VAMPYRE == 1 ]
#    then
      mv ../../../tmp/main/Im*.ppu ../../../3rdparty/bin/win/
      mv ../../../tmp/main/Im*.o ../../../3rdparty/bin/win/
      mv ../../../tmp/main/im*.ppu ../../../3rdparty/bin/win/
      mv ../../../tmp/main/im*.o ../../../3rdparty/bin/win/
      mv ../../../tmp/main/dzlib.ppu ../../../3rdparty/bin/win/
      mv ../../../tmp/main/dzlib.o ../../../3rdparty/bin/win/
#    fi
 fi
fi

if [ $BUILD_LINUX == 1 ]
then
#new strategy: using built-in modules for all platforms except Win32.


  rm ../../../chentrah
  fpc ../../chentrah/src/chentrah.lpr ${CGE_OPTIONS} -Tlinux -FU/tmp/.chentrah/main/ ${CGE_PATHS} ${VY_PATHS}  -dbuildmein -FE../../../
  ../../../bin/extractdwrflnfo ../../../chentrah
  strip   -s -x -X  ../../../chentrah
  ../../../bin/finalizedwrflnfo ../../../chentrah
  mv ../../../chentrah.elf.zd2 ../../chentrah/bin/${MODNAME}.elf.zd2
  mv ../../../chentrah ../../../${MODNAME}

  # *.a are generated only with the -CX key (I do not use it, see above).
#  if [ $COMPILE_VAMPYRE == 1 ]
#  then
    mv /tmp/.chentrah/main/Im*.ppu ../../../3rdparty/bin/lin/
    mv /tmp/.chentrah/main/Im*.o ../../../3rdparty/bin/lin/
  #  mv /tmp/.chentrah/libpIm*.a ../../../3rdparty/bin/lin/
    mv /tmp/.chentrah/main/im*.ppu ../../../3rdparty/bin/lin/
    mv /tmp/.chentrah/main/im*.o ../../../3rdparty/bin/lin/
  #  mv /tmp/.chentrah/libpim*.a ../../../3rdparty/bin/lin/
    mv /tmp/.chentrah/main/dzlib.ppu ../../../3rdparty/bin/lin/
    mv /tmp/.chentrah/main/dzlib.o ../../../3rdparty/bin/lin/
  #  mv /tmp/.chentrah/libpdzlib.a ../../../3rdparty/bin/lin/
#  fi
fi



