{
    This file is part of Chentrah,
    Copyright (C) 2004-2015 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}

// The server framework is stub framework. It does nothing.


{$longstrings on}
{$codepage utf-8}

unit cl_framework_server;

interface

uses SysUtils, Windows, cge;

type

  TServerFramework = class (TAbstractFramework)
  public
     constructor Create; override;
     destructor Destroy; override;
     procedure SetPointerImage(p: pointer; xhs, yhs: integer); override;
     procedure SwapBuffers; override;
     function MouseX: float; override;
     function MouseY: float; override;
     procedure SetVolume(volume: float); override;
     procedure NewSoundData(begins: TDateTime; samples, rate: integer; data: pointer); override;
     procedure PlaySound(samples, rate: integer; data: pointer); override;
     procedure PlayWav(filename: TFileNameString); override;
     procedure CheckBatteryStatus; override;
     Procedure MainThreadLoop; override;
     procedure SetWindowName(n: PUnicodeChar); override;
  end;

implementation

  constructor TServerFramework.Create;
  begin
    inherited;
    Cge.Framework:= Self;
    CheckBatteryStatus;
  end;

  destructor TServerFramework.Destroy;
  begin
    pointer(Cge.Framework) := nil;
    inherited;
  end;

  procedure TServerFramework.CheckBatteryStatus;
  begin
    Mother^.State.BatteryRemaining:= 255;
  end;

  Procedure TServerFramework.MainThreadLoop;
  begin
    Die('NOT IMPLEMENTED YET!');
    //***TODO
  end;

  procedure TServerFramework.SetPointerImage(p: pointer; xhs, yhs: integer);
  begin
  end;

  // performs OpenGL's SwapBuffers for the main framebuffer, nothing more.
  procedure TServerFramework.SwapBuffers;
  begin
  end;


  function TServerFramework.MouseX: float;
  begin
    Result:= 0;
  end;


  function TServerFramework.MouseY: float;
  begin
    Result:= 0;
  end;

  procedure TServerFramework.SetVolume(volume: float);
  begin
  end;


  procedure TServerFramework.NewSoundData(begins: TDateTime; samples, rate: integer; data: pointer);
  begin
  end;


  procedure TServerFramework.PlaySound(samples, rate: integer; data: pointer);
  begin
  end;


  procedure TServerFramework.PlayWav(filename: TFileNameString);
  begin
  end;

  procedure TServerFramework.SetWindowName(n: PUnicodeChar);
  begin
    //do nothing
  end;




initialization
  TAbstractFramework.RegisterFramework(TServerFramework, 'Server');
finalization

end.
