{
    This file is part of Chentrah,
    Copyright (C) 2004-2008 Anton Rzheshevski (chebmaster@mail.ru).

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see http://www.gnu.org/licenses/

 **********************************************************************}


//  function SetWindowLong(hWnd:HWND; nIndex:longint; dwNewLong:cardinal):cardinal; stdcall; external 'user32' name 'SetWindowLongA';
  

{  var
    glob_focus: boolean = true;
 }

  const
    WindowedStyle: dword = WS_CAPTION or WS_SYSMENU or WS_SIZEBOX or WS_VISIBLE or WS_MAXIMIZEBOX or WS_MINIMIZEBOX or WS_CLIPCHILDREN;
    WindowedExStyle: dword =  WS_EX_APPWINDOW or WS_EX_WINDOWEDGE;
    FullscreenStyle: dword =  dword(WS_POPUP) or dword(WS_MAXIMIZE) or dword(WS_VISIBLE) or dword(WS_CLIPCHILDREN);
    FullscreenExStyle: dword =  WS_EX_APPWINDOW or WS_EX_TOPMOST;

  var gv_FramesSinceLeavingFullscreen: int64 = 0;

  procedure TWindowmanager._UploadPointer;
  var
    cursorInfo: TIconInfo;
    cursor: THandle;
    OldCursor: HCursor;
    EmptyBitmap, EmptyMask: array[0..((32*32) div 8) - 1] of byte;
  begin
    _UploadGLcursor;
    OldCursor:= icon_hwcursor;

    if Mother^.Display.UseHardware1bitCursor
      then icon_hwcursor:= CreateCursor(
        system.Hinstance, PointerXHotSpot, PointerYHotSpot, 32, 32, @PointerBitmap.AndMask, @PointerBitmap.XorMask)
      else begin
        FillChar(EmptyMask, Sizeof(EmptyBitmap), $ff);
        FillChar(EmptyBitmap, Sizeof(EmptyBitmap), 0);
        icon_hwcursor:= CreateCursor(system.Hinstance, 1, 1, 32, 32, @EmptyMask, @EmptyBitmap);
      end;
    SetCursor(icon_hwcursor);

    if CursorCreated then DestroyCursor(OldCursor);
    CursorCreated:= Yes;
  end;
  
  // Эта процедура обрабатывает приходящие в адрес окна сообщения.
  function WndProc(hWnd: HWND; Msg: UINT;  wParam: WPARAM;  lParam: LPARAM): LRESULT; stdcall;
  begin
    if not (Assigned(Framework) and Assigned((Framework as TWinApiFramework).WindowManager))
      then Exit(DefWindowProc(hWnd, Msg, wParam, lParam));
    case msg of
     WM_ACTIVATE: begin
       // cannot be processed in the main message loop:
       // arrives only here, in the window procedure
       Case LOWORD(wParam) of
        WA_ACTIVE, WA_CLICKACTIVE:
          if (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs in [wsco_Minimized, wsco_NoFocus]
          then begin
            (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_Normal;
            if Mother^.Debug.Verbose then AddLog('The application window is activated. Commanding the window manager to switch to the default windowed mode.');
          end;
        WA_INACTIVE:
          if ((Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs in [wsco_Normal, wsco_Maximized])
          then begin
            (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_NoFocus;
            if Mother^.Debug.Verbose then AddLog('The application window is deactivated. Commanding the window manager to switch to the no-focus windowed mode.');
          end;
       end;
     end;
     WM_SYSCOMMAND: begin
       Case (wParam and $FFF0) of
        {MSDN: In WM_SYSCOMMAND messages, the four low-order bits of the wParam parameter
        are used internally by the system. To obtain the correct result when testing
        the value of wParam, an application must combine the value 0xFFF0 with the
        wParam value by using the bitwise AND operator.}
{         SC_HOTKEY, SC_TASKLIST:
           if (Assigned(Framework) and Assigned((Framework as TWinApiFramework).WindowManager) and (Framework as TWinApiFramework).WindowManager.Focus and (Framework as TWinApiFramework).WindowManager.MustBeMaximized//Mother^.Display.InFullScreenMode
             then (Framework as TWinApiFramework).WindowManager.MustBeMaximized:= false;//Exit(-1);
}        SC_CLOSE: begin
           if Mother^.Debug.Verbose then AddLog('The OS commands the application window to be closed.Processing normally.');
         end;
         SC_MAXIMIZE: begin
            if ((Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs <> wsco_Maximized)
            then begin
              if gv_FramesSinceLeavingFullscreen < 2 then begin
                if Mother^.Debug.Verbose then AddLog('The OS commands the application window to be maximized. Since it was less than 2 frames ago since leaving fullscreen, simply blocking the maximization.');
              end
              else begin
                if Mother^.Debug.Verbose then AddLog('The OS commands the application window to be maximized. Preventing the OS from doing that. Commanding the window manager to switch to fullscreen instead.');
                (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_Maximized;
              end;
            end
            else
              if Mother^.Debug.Verbose then AddLog('The OS commands the application window to be maximized. This makes no sense, it is already fullscreen. Simply rejecting the command and doing nothing.');
            Exit(1); //Do NOT let Windows to maximize the window.
         end;
         SC_RESTORE: begin
           if (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs in [wsco_Minimized, wsco_Maximized] then begin
             if Mother^.Debug.Verbose then AddLog('The OS commands the application window to restore its size and posiztion. Commanding the window manager to switch to default windowed mode.');
             (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_Normal;
           end
           else
             if Mother^.Debug.Verbose then AddLog('The OS commands the application window to restore its size and posiztion. Letting the OS process this..');
         end;
         SC_MINIMIZE: begin
           if ((Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs <> wsco_Minimized)
           then begin
             if Mother^.Debug.Verbose then AddLog('The OS commands the application window to be minimized. Commanding the window manager to switch to the minimized mode.');
           end
           else
             if Mother^.Debug.Verbose then AddLog('The OS commands the application window to be inimized. This makes no sense, it is already minimized.');
         end;
//else addlog('WM_SYSCOMMAND (%0, %1)',[IntToHex(wparam, 4), IntToHex(lparam, 8)]);
       end;

     end;
     WM_KILLFOCUS: begin
        (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_NoFocus;
        if Mother^.Debug.Verbose then AddLog('The application window loses focus. Commanding the window manager to switch to the no-focus windowed mode.');
      end;
     WM_SETFOCUS: begin
       if ((Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs <> wsco_Maximized)
       then begin
        (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_Normal;
        if Mother^.Debug.Verbose then AddLog('The application window receives focus. Commanding the window manager to switch to default windowed mode.');
      end
      else
        if Mother^.Debug.Verbose then AddLog('The application window receives focus. This makes no sense, we are already fullscreen.');
     end;
     WM_SYSKEYDOWN: begin
       case wparam of
         VK_F10: begin
           if Mother^.Debug.Verbose then AddLog('The application window received system command "F10 pressed" to activate menu bar. Blocking it to allow using the F10 key.');
           Exit(DefWindowProc(hWnd, WM_KEYDOWN, wParam, lParam));
         end;
         else
           if (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs = wsco_Maximized
           then begin
             (Framework as TWinApiFramework).WindowManager.WindowStateCommandedByTheOs:= wsco_Normal;
             if Mother^.Debug.Verbose then AddLog('A system key was pressed! Commanding the window manager to switch to default windowed mode.');
           end;
       end;
//       if wparam <> VK_MENU then AddLog('Window received WM_SYSKEYDOWN (%0, %1)', [IntToHex(wparam, 4), IntToHex(lparam, 8)]);
     end;
     WM_SYSKEYUP: begin
       case wparam of
         VK_F10: begin
           if Mother^.Debug.Verbose then AddLog('The application window received system command "F10 released". Blocking it to allow using the F10 key.');
           Exit(DefWindowProc(hWnd, WM_KEYUP, wParam, lParam));
         end;

       end;

//       if wparam <> VK_MENU then AddLog('Window received WM_SYSKEYDOWN (%0, %1)', [IntToHex(wparam, 4), IntToHex(lparam, 8)]);

     end;

{ $200:;
$20:;
$7f:;
$84:;
$104:;
else addlog('WindowProc (, %0, %1, %2)',[IntToHex(msg, 8), IntToHex(wparam, 4), IntToHex(lparam, 8)]);
}
    end;
    Result := DefWindowProc(hWnd, Msg, wParam, lParam)    // Default result if nothing happens
  end;
  

(*
  if (fullscreen)												// Are We Still In Fullscreen Mode?
  {
  	dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
  	dwStyle=WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;	// Windows Style
  	ShowCursor(FALSE);										// Hide Mouse Pointer
  }
  else
  {
  	dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;						// Window Extended Style
  	dwStyle=WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;	// Windows Style
  }

  *)



  // http://msdn.microsoft.com/en-us/library/dd162826%28v=vs.85%29.aspx
(*

void ClipOrCenterRectToMonitor(LPRECT prc, UINT flags)
{
    HMONITOR hMonitor;
    MONITORINFO mi;
    RECT        rc;
    int         w = prc->right  - prc->left;
    int         h = prc->bottom - prc->top;

    //
    // get the nearest monitor to the passed rect.
    //
    hMonitor = MonitorFromRect(prc, MONITOR_DEFAULTTONEAREST);

    //
    // get the work area or entire monitor rect.
    //
    mi.cbSize = sizeof(mi);
    GetMonitorInfo(hMonitor, &mi);

    if (flags & MONITOR_WORKAREA)
        rc = mi.rcWork;
    else
        rc = mi.rcMonitor;

    //
    // center or clip the passed rect to the monitor rect
    //
    if (flags & MONITOR_CENTER)
    {
        prc->left   = rc.left + (rc.right  - rc.left - w) / 2;
        prc->top    = rc.top  + (rc.bottom - rc.top  - h) / 2;
        prc->right  = prc->left + w;
        prc->bottom = prc->top  + h;
    }
    else
    {
        prc->left   = max(rc.left, min(rc.right-w,  prc->left));
        prc->top    = max(rc.top,  min(rc.bottom-h, prc->top));
        prc->right  = prc->left + w;
        prc->bottom = prc->top  + h;
    }
}

  void ClipOrCenterWindowToMonitor(HWND hwnd, UINT flags)
  {
      RECT rc;
      GetWindowRect(hwnd, &rc);
      ClipOrCenterRectToMonitor(&rc, flags);
      SetWindowPos(hwnd, NULL, rc.left, rc.top, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
  }
*)

  function TWindowmanager.GetScreenRect(fullscreen: boolean): TWindowManagerRect;
  var
    rc: TRect;
    Monitor: HMONITOR;
    mi: TMonitorInfo;
  begin
    if Mother^.State.OS in [ostWin98, OstWin2k] then with Result do begin
      //Use legacy method fow windozes older than XP
      left:= 0;
      top := 0;
      width:= GetSystemMetrics(SM_CXSCREEN);
      height:= GetSystemMetrics(SM_CYSCREEN);
      //Assuming that taskbar is at the bottom and is 28 pixels high:
      if not Fullscreen then Height-= 28;
    end
    else begin
      if Mother^.Display.windowhandle = 0 then begin
        //Not created yet. Use default monitor.
         with rc do begin
           left:= 0;
           top:= 0;
           right:= 1;
           bottom:= 1;
         end;
         Monitor:= MonitorFromRect(rc, MONITOR_DEFAULTTOPRIMARY);
      end else begin
        //get monitor from window
        GetWindowRect(Mother^.Display.windowhandle, rc);
        Monitor:= MonitorFromRect(rc, MONITOR_DEFAULTTONEAREST);
      end;
      mi.cbSize:= sizeof(mi);
      GetMonitorInfo(Monitor, @mi);
      if fullscreen
        then rc:= mi.rcMonitor
        else rc:= mi.rcWork;
      Result.left:= rc.left;
      Result.top:= rc.top;
      Result.width:= rc.right - rc.left;
      Result.height:= rc.bottom - rc.top;
     end;
  end;

  function WmRectToWindowsRect(r: TWindowManagerRect): TRect;
  begin
    Result.left:= r.left;
    Result.top:= r.top;
    Result.right:= r.left + r.width;
    Result.bottom:= r.top + r.height;
  end;

  function WindowsRectToWmRect(r: TRect): TWindowManagerRect;
  begin
    Result.left:= r.left;
    Result.top:= r.top;
    Result.width:= r.Right - r.left;
    Result.height:= r.Bottom - r.top;
  end;

  function RectToStr(r: TWindowManagerRect) : UnicodeString;
  begin
    with r do
      Result:= PervertedFormat('%0x%1(%2,%3)',[width, height, left, top]);
  end;

  function TWindowmanager.GetWindowOuterRect(): TWindowManagerRect;
  var r: TRect;
  begin
    GetWindowRect(Mother^.Display.WindowHandle, r);
    Result:= WindowsRectToWmRect(r);
  end;


  function TWindowmanager.GetWindowClientRect(): TWindowManagerRect;
  var
    r: TRect;
    point: TPoint;
  begin
    point.x:= 0;
    point.y:= 0;
    GetClientRect(Mother^.Display.WindowHandle, r); //This suka always returns 0,0 for the top left corner!
    ScreenToClient(Mother^.Display.WindowHandle, point);
    Result:= WindowsRectToWmRect(r);
    Result.Top-= point.x;
    Result.Left-= point.y;
  end;


  procedure TWindowmanager.CreateWindow;
  var
    wndClass : TWndClass;
    s: string;
  begin
    if Mother^.Debug.Verbose then AddLog('Screen rect is %0',[RectToStr(Mother^.Display.ScreenRect)]);

    if Mother^.Debug.Verbose then AddLog('Creating the window...');

    if Mother^.Display.InFullScreenMode then begin
      dwStyle:= FullscreenStyle;
      dwExStyle:= FullscreenExStyle;
    end else begin
      dwStyle:= WindowedStyle;
      dwExStyle:= WindowedExStyle;
    end;

    s:=AppNick+'_OpenGL_WND';

    // Заполняем бланк-формуляр, которым будем кормить процедуру создания класса окна
    ZeroMemory(@wndClass, SizeOf(wndClass));
    with wndClass do begin
      style         := CS_HREDRAW or    // Перерисовывать окно целиком при изменении ширины
                       CS_VREDRAW or    // ...то же, для высоты
                       CS_OWNDC;        // Окну нужен собственный контекст устройства
      lpfnWndProc   := @WndProc;        // Оконная процедура, которая будет ловить мессаги
      hInstance := {$ifdef fpc}
                    System.HInstance;
                   {$else}
                    SysInit.HInstance;
                   {$endif}
      lpszClassName := PChar(s);
      hIcon:= LoadIcon({$ifdef fpc}System.HInstance{$else}SysInit.Hinstance{$endif}, PChar('MAINICON'));
    end;

    // Регистрируем класс окна (ну, вот нельзя так просто создать окно - ещё,
    //   види-те ли, класс нужен... Нет, явно Виндовс писали извращенцы.)
    if (0 = RegisterClass(wndClass)) then Die('RegisterClass() returned 0');

{    wmr:= GetScreenRect(true);
    Mother^.Display.ScreenWidth:= wmr.width;//GetSystemMetrics(SM_CXSCREEN);
    Mother^.Display.ScreenHeight:= wmr.height;//GetSystemMetrics(SM_CYSCREEN);

    if not Mother^.Display.InFullScreenMode then begin
     //adjust the initial width and height with regards to the window decorations
      _rect.left:=1;
      _rect.top:=1;
      _rect.right:=Mother^.Display.WindowClientWidth;
      _rect.bottom:=Mother^.Display.WindowClientHeight;
      AdjustWindowRectEx(_Rect, dwStyle, false, dwExStyle);
      Mother^.Display.WindowClientWidth:=_rect.right - _rect.left + 1;
      Mother^.Display.WindowClientHeight:=_rect.bottom - _rect.top + 1;
      w:= Mother^.Display.WindowClientWidth;
      h:= Mother^.Display.WindowClientHeight;
      l:= round(Mother^.Display.WindowedOriginX * Mother^.Display.ScreenWidth);
      t:= round(Mother^.Display.WindowedOriginY * Mother^.Display.ScreenHeight);
    end else begin
      w:= Mother^.Display.ScreenWidth;
      h:= Mother^.Display.ScreenHeight;
      l:=0;
      t:=0;
    end;
 }

    if Mother^.Debug.Verbose then AddLog('The window rect, as read from the config and clipped to the screen rect, should be %0',[RectToStr(Mother^.Display.WindowRect)]);

    // Создаём окно
    with Mother^.Display.WindowRect do begin
      if {$ifdef cpu32}not Assigned(CreateWindowExW) or {$endif}
        Mother^.State.Windows98.DoesNotSupportUnicode
      then begin
        Mother^.Display.WindowHandle:= CreateWindowEx(
          dwExStyle, PChar(s),
          PChar(WideToAnsi(MessageContainer[MI_CGE_TITLE])), dwStyle,
            left, top, width, height, 0, 0, hInstance, nil);
      end
      else begin
        Mother^.Display.WindowHandle:= CreateWindowExW(
          dwExStyle, PUnicodeChar(AnsiToWide(s)),
          PUnicodeChar(MessageContainer[MI_CGE_TITLE]), dwStyle,
            left, top, width, height, 0, 0, hInstance, nil);
      end;
    end;
    if Mother^.Display.WindowHandle = 0
      then Die('CreateWindowEx() returned 0');

    //SetForegroundWindow(Mother^.Display.WindowHandle);


    Mother^.Display.WindowRect:= GetWindowOuterRect();
    Mother^.Display.WindowClientRect:= GetWindowClientRect();
    formerClientRect:= Mother^.Display.WindowClientRect;
    Mother^.Display.WindowExists:= True;
    Mother^.Display.CanRender:= true;



    if Mother^.Debug.Verbose then AddLog('Window created. Client area %0, window %1, fullscreen=%2',[
      RectToStr(Mother^.Display.WindowClientRect), RectToStr(Mother^.Display.WindowRect),
      Mother^.Display.InFullScreenMode
    ]);
  end;

  procedure  TWindowmanager.CloseWindow;
  begin
    if not Mother^.Display.WindowExists then begin
      AddLog(RuEn(
        'Не удалось удалить окно за неимением такового.',
        'Unable to destroy the window due to absence of it.'));
      Exit
    end
    else begin
      if (Mother^.Display.WindowHandle <> 0)
        and IsWindow(Mother^.Display.WindowHandle)
        and not DestroyWindow(Mother^.Display.WindowHandle)
      then begin
        AddLog('DestroyWindow() call failed!');
        Mother^.Display.WindowHandle := 0;
      end
      else
        if Mother^.Debug.Enabled then AddLog('Window destroyed.');
    end;
    // Снимаем с учёта класс окна
    if (not Windows.UnRegisterClass(PChar(AppNick+'_OpenGL_WND'), hInstance))
    then  AddLog('UnRegisterClass() call failed!');
    
    Mother^.Display.CanRender:= false;
    Mother^.Display.WindowExists:=False;

    if CursorCreated then DestroyCursor(icon_hwcursor);
  end;

  {$ifndef fpc}
  function GetKeyboardState(lpKeyState:PBYTE):WINBOOL; external 'user32' name 'GetKeyboardState';
  {$endif}

(*
  procedure TWindowmanager.GrabPointer;
  var
    _rect: TRect;
    point: TPoint;
  begin
{
    _DeltaMouse:=true;
      GetClientRect(WindowHandle, rect);
      point.x:=rect.right div 2;
      point.y:=rect.bottom div 2;
      ClientToScreen(Windowhandle, Point);
      SetCursorPos(point.x, point.y);
      
   }
  end;
  
  procedure TWindowmanager.UngrabPointer;
  begin
  
  end;

*)

  const
    MAPVK_VK_TO_VSC = 0;
    MAPVK_VK_TO_VSC_EX = 4;
  function DivineScanCode(var msg: TMSG): integer; //as in "divination", not "divinity".
  begin
    { Note: Wine behaves differently.
        In the original Windows, bit 24 (extended keyboard key)
        is duplicated in the bit 23 of the scancode itself.
        Wine doesn't do that.}
    Result:= ((msg.lParam shr 16) and $FF) or ((msg.lParam shr 17) and $80);
{   if (Mother^.State.OS in WindowsEmulators) then case Result of
      ***TODO   ДОДЕЛАТЬ!
      $xx: Result:= KEY_LEFT_WINDOWS;
      $xx: Result:= KEY_RIGHT_WINDOWS;
      $xx: Result:= KEY_APP_MENU;
    end;}
  end;


  function TWindowmanager.GetIsWindowFullscreen(): boolean;
  var s: ptruint;
  begin
    s:= {$ifdef cpu64}GetWindowLongPtr{$else}GetWindowLong{$endif}
      (Mother^.Display.WindowHandle, GWL_STYLE);
    Result:= (s and WS_POPUP) <> 0;
  end;

  function TWindowmanager.GetIsWindowMinimized(): boolean;
  var s: ptruint;
  begin
    s:= {$ifdef cpu64}GetWindowLongPtr{$else}GetWindowLong{$endif}
      (Mother^.Display.WindowHandle, GWL_STYLE);
    Result:= (s and WS_MINIMIZE) <> 0;
  end;


  procedure TWindowmanager.CheckWindowSize;
  var
    AtNSZ: boolean = false; //adjust to new screen size
  begin
    //each frame. A dumb but *robust* method.
    Mother^.Display.ScreenRect:= GetScreenRect(Mother^.Display.InFullScreenMode); //Width:= GetSystemMetrics(SM_CXSCREEN);
    Mother^.Display.FullscreenRect:= GetScreenRect(true);
    Mother^.Display.WindowRect:= GetWindowOuterRect;
    Mother^.Display.WindowClientRect:= GetWindowClientRect;
//    Mother^.Display.ScreenHeight:= GetSystemMetrics(SM_CYSCREEN);
//    GetClientRect(Mother^.Display.WindowHandle, rect);
    case f_wsco of
      wsco_Normal, wsco_NoFocus: begin

      //Was nice idea but it FUCKING DOESN"T WORK!
      //Windows 7 simply ignores my calls to SetWindowPos() and MoveWindow() and resizes the window how it sees fit.
(*
        if (formerw <> Mother^.Display.ScreenWidth) or (formerh <> Mother^.Display.ScreenHeight)
        then begin
          l:= round(Mother^.Display.WindowedOriginX * Mother^.Display.ScreenWidth);
          t:= round(Mother^.Display.WindowedOriginY * Mother^.Display.ScreenHeight);
          w:= round(Mother^.Display.WindowedWidth * Mother^.Display.ScreenWidth);
          h:= round(Mother^.Display.WindowedHeight * Mother^.Display.ScreenHeight);

          AddLog(RuEn(
            'Внезапно! Размер экрана изменился (было %0х%1, стало %2х%3). Корректирую размер и положение окна на %4,%5 (%6х%7).',
            'Suddenly! The screen size changed (was %0x%1, now is %2x%3). Correcting the size and position of the window to %4,%5 (%6x%7).')
            ,[formerw, formerh, Mother^.Display.ScreenWidth, Mother^.Display.ScreenHeight,l,t,w,h]);
          //simply reset some values to bogus so that the algorithms below activate:
          //ShowWindow(Mother^.Display.WindowHandle,SW_RESTORE);//FTF does it get minimized somehow during the transition?
          if not MoveWindow(Mother^.Display.WindowHandle,l,t,w,h, false) then Die('MoveWindow() retuened false!');
          AtNSZ:= true;
        end;
*)

        if (formerClientRect <> Mother^.Display.WindowClientRect)
          and not GetIsWindowFullscreen
            //Because f_wsco denotes *desired* state, not thereal state
            //of the window. Windows window management has its say too.
        then begin
          //that wine hack again (two frames after return from fullscreen,
          //  the window suddenly gets repositioned slightly to the left and top
          //  of the screen)
          if not ((Mother^.State.OS = ostWine) and (gv_FramesSinceLeavingFullscreen < 3))

          then with Mother^.Display.WindowRect do begin
            Config.Float['video', 'window_width']:= width / Mother^.Display.ScreenRect.Width;
            Config.Float['video', 'window_height']:= height / Mother^.Display.ScreenRect.height;
            Config.Float['video', 'window_left']:= (left - Mother^.Display.ScreenRect.left) / Mother^.Display.ScreenRect.width;
            Config.Float['video', 'window_top']:= (top - Mother^.Display.ScreenRect.top) / Mother^.Display.ScreenRect.height;
          end;
          if Mother^.Debug.Verbose then AddLog('Application window resized or moved, the client area is %0, the entire window including decorations is %1',
            [RectToStr(Mother^.Display.WindowClientRect), RectToStr(Mother^.Display.WindowRect)]);
        end;
        formerClientRect:= Mother^.Display.WindowClientRect;
      end;
    wsco_Maximized: begin
      if
        Mother^.Display.ScreenRect <> formerScreenRect
        then begin
          AddLog(RuEn(
            'Внезапно! Размеры окна не равны размерам экрана: %0, было %1. Корректирую.',
            'Suddenly! Window size doesn''t match screen size: %0, was %1. Correcting.')
            ,[RectToStr(Mother^.Display.ScreenRect), RectToStr(formerScreenRect)]);

          with Mother^.Display.ScreenRect do
            if not SetWindowPos(
               Mother^.Display.WindowHandle, HWND_TOPMOST, left, top, width, height, 0)
                    then Die('Failed to adjust window size!');
          Mother^.Display.WindowRect:= GetWindowOuterRect;
          Mother^.Display.WindowClientRect:= GetWindowClientRect;
        end;
      formerScreenRect:= Mother^.Display.ScreenRect;
      end;
    end;

    case Mother^.Display.RequestedFullScreenMode of
      -1: begin
          if f_wsco = wsco_Maximized then begin
            f_wsco:= wsco_Normal;
             if Mother^.Debug.Verbose then AddLog('The window manager is commanded to switch to windoweed mode.');
            Config.Bool['video', 'fullscreen']:= false;
          end;
          Mother^.Display.RequestedFullScreenMode:= 0;
        end;
       1: begin
           if f_wsco <> wsco_Maximized then begin
             f_wsco:= wsco_Maximized;
              if Mother^.Debug.Verbose then AddLog('The window manager is commanded to switch to fullscreen mode.');
             Config.Bool['video', 'fullscreen']:= true;
           end;
           Mother^.Display.RequestedFullScreenMode:= 0;
        end;
    end;
    Mother^.Display.CanRender:= not GetIsWindowMinimized
      and (Mother^.Display.WindowClientRect.width >= 256)
      and (Mother^.Display.WindowClientRect.height >= 256)

  end;

  Procedure TWindowmanager.Heartbeat;
  var
    msg: TMsg;
    i, oldmx, oldmy, px, py: integer;
    point: TPoint;
    KeyboardState: array[0..255] of byte;
    buff: array[0..10] of UnicodeChar;
    abuff: array[0..10] of AnsiChar;
    numchars: integer;
    scancode: integer;
    cr: TWindowManagerRect;

    procedure CheckIfMouseMoved(per_cycle: boolean = false);
    begin
      if f_wsco = wsco_Minimized then Exit;
      GetCursorPos(point);
      px:= point.x;
      py:= point.y;
      ScreenToClient(Mother^.Display.WindowHandle, point);
      if per_cycle then begin
        oldmx:=f_MouseX;
        oldmy:=f_MouseY;
      end;
      f_MouseX:=point.x;
      f_MouseY:=point.y;
      Mother^.Display.MouseIsBeyondOurWindow:= (f_MouseY < 0) or (f_MouseX < 0)
                              or (f_MouseY > Mother^.Display.WindowClientRect.Height)
                              or (f_MouseX > Mother^.Display.WindowClientRect.Width);
      if ((f_MouseX <> oldmx) or (f_MouseY <> oldmy)) and (per_cycle) then OnMouseMove;
//here goes the code for handling the grabbed pointer *********************************
// *********************  IMPLEMENT IT! ***********************************************
    end;

    procedure GoFullscreen;
    var
      _rect: TRect;
      dwStyle, dwExStyle: dword;
    begin
      Mother^.Display.ScreenRect:= GetScreenRect(true); //Width:= GetSystemMetrics(SM_CXSCREEN);
      AddLog(RuEn(
        'Переключение в полноэкранный режим (%0х%1)...',
        'Switching to full screen mode (%0x%1)...'
        ), [Mother^.Display.ScreenRect.Width, Mother^.Display.ScreenRect.Height]
      );
      dwStyle:= dword(WS_POPUP) or dword(WS_MAXIMIZE) or dword(WS_VISIBLE) or dword(WS_CLIPCHILDREN);
      dwExStyle:= WS_EX_APPWINDOW or WS_EX_TOPMOST;
      with Mother^.Display.ScreenRect do
      if (0 = {$ifdef cpu64} SetWindowLongPtr {$else} SetWindowLong {$endif} (
        Mother^.Display.WindowHandle, GWL_STYLE, dwStyle))
      or (0 = {$ifdef cpu64} SetWindowLongPtr {$else} SetWindowLong {$endif} (
        Mother^.Display.WindowHandle, GWL_EXSTYLE, dwExStyle))
      or not SetWindowPos(
        Mother^.Display.WindowHandle, HWND_TOPMOST, left, top, width, height, 0)
      then Die('Failed to change the window to fullscreen!');
      Mother^.Display.InFullScreenMode:= true;
      Mother^.Display.WindowRect:= GetWindowOuterRect;
      Mother^.Display.WindowClientRect:= GetWindowClientRect;
      Config.Bool['video', 'fullscreen']:= true;
      AddLogOk;
    end;

    procedure LeaveFullScreen;
    var
      _rect: TRect;
    begin
      Config.Bool['video', 'fullscreen']:= false;
      AddLog(RuEn(
        'Переключение из полноэкранного в оконный режим...',
        'Switching from fullscreen to windowed mode...'
      ));
      gv_FramesSinceLeavingFullscreen:= 0;
      dwStyle:= WindowedStyle;
      dwExStyle:= WindowedExStyle;
      Mother^.Display.ScreenRect:= GetScreenRect(false);
      LoadWindowRectFromConfig;
      with Mother^.Display.WindowRect do
      if (0 = {$ifdef cpu64} SetWindowLongPtr {$else} SetWindowLong {$endif} (
        Mother^.Display.WindowHandle, GWL_STYLE, dwStyle))
      or (0 = {$ifdef cpu64} SetWindowLongPtr {$else} SetWindowLong {$endif} (
        Mother^.Display.WindowHandle, GWL_EXSTYLE, dwExStyle))
      or not SetWindowPos(
        Mother^.Display.WindowHandle, HWND_NOTOPMOST,
         left, top, width, height, 0)
      then Die('Failed to change the window from fullscreen to windowed!');
      Mother^.Display.InFullScreenMode:= false;
      Mother^.Display.WindowRect:= GetWindowOuterRect;
      Mother^.Display.WindowClientRect:= GetWindowClientRect;
      if Mother^.Debug.Verbose then AddLog('  the client area is %0, the entire window including decorations is %1',
        [RectToStr(Mother^.Display.WindowClientRect), RectToStr(Mother^.Display.WindowRect)]);
    end;

  begin
    if IsWindow(Mother^.Display.WindowHandle) then begin
      NoteThreadOccupation(tlk_PollingInput);
    { 2006: я уже задолбался
      отлавливать все возможные варианты закрытия окна,
      после которого ни о чём не догадывающаяся программа продолжает работать,
      не отображаясь на Панели задач, но грузя процессор и деловито
      отправляя в никуда поток команд OpenGL... :(
    }

      f_focus:= (f_wsco in [wsco_Normal, wsco_Maximized]) and (GetForegroundWindow() {GetFocus()} = Mother^.Display.WindowHandle);
      f_HadMessages:= false;
      if f_focus
        then f_LoseFocusFramesCount:=0
        else inc(f_LoseFocusFramesCount);
   (*
      if Mother^.Display.InFullScreenMode and not f_focus then begin
        LogGoDown(RuEn('окно потеряло фокус','the window lost focus'));
        Mother^.State.ExitRequested:=true;
      end
      else begin
   *)
      CheckWindowSize;
      if Assigned((Framework as TWinApiFramework).WinTabManager) then begin
        (Framework as TWinApiFramework).WinTabmanager.Pulse;
        for i:=0 to high((Framework as TWinApiFramework).WinTabManager.Events) do
          with (Framework as TWinApiFramework).WinTabManager.Events[i] do
            OnPen((x * Mother^.Display.FullscreenRect.width) - (Mother^.Display.FullscreenRect.left - Mother^.Display.WindowClientRect.left),
                  ((1-y) * Mother^.Display.FullscreenRect.Height) - (Mother^.Display.FullscreenRect.top - Mother^.Display.WindowClientRect.top),
                  pressure, reserved1, reserved2, reserved3);
      end;
      CheckIfMouseMoved(true);
      _CheckCursorMode();
      While PeekMessage(msg, 0, 0, 0, PM_REMOVE) do begin
        case msg.message of
          WM_KEYDOWN:
            begin
              f_HadMessages:= true;
              scancode:= DivineScanCode(msg);
              numchars:=0;
              if Mother^.Input.TextInput then begin
                GetKeyboardState(@KeyboardState[0]);
{ //Researching the Unicode support state in the vanilla Windows 98 SE:
addlog('ToUnicode: %0 %1',[msg.wparam, (msg.lParam shr 16) and $FF]);
addlog('-----------------------------------');
addlog('%0  %1',[msg.wparam, (msg.lparam shr 16) and $ff]);
for i:=0 to 255 do addlog('%0,',[KeyboardState[i]]);
addlog('------------------------');
}
                numchars:=ToUnicode(msg.wparam, (msg.lParam shr 16) and $FF, @KeyboardState[0], @buff[0], 10, 0);
                if (NumChars = 0) and (Mother^.State.OS = ostWin98) then begin
                  //Windows 98 doesn't have the Unicode support installed.
                  //  Assuming system locale to be Russian/Cyrillic CP1251
                  numchars:= ToAscii(msg.wparam, (msg.lParam shr 16) and $FF, @KeyboardState[0], @abuff[0], 0);
                  for i:=0 to numchars - 1 do
                    buff[i]:= Cp1251CharToUnicodeChar(abuff[i]);
                end;
              end;
              if ((msg.lParam and $FFFF ) = 1)
                or (Mother^.Input.TextInput and (TKey(scancode) in KeysAcceptingAutoRepeatInTextInputMode))
              then begin
                if ({(numchars < 1) and} (TKey(scancode) < KEY_MWHEEL_DOWN))
                  or (TKey(scancode) in KeysWorkingInTextInputMode)
                then begin
                  if (not f_KeyState[scancode])
                    or (Mother^.Input.TextInput and (TKey(scancode) in KeysAcceptingAutoRepeatInTextInputMode))
                  then begin
                    f_KeyState[scancode]:=true;
                    CheckIfMouseMoved();
                    OnPress(scancode);
                  end;
                end;
                for i:=0 to numchars - 1 do
                  if buff[i] >= ' ' //no special characters!
                    then begin
                      OnType(buff[i]);
                      OnPress(0); {notify the recipient of the updates,
                                   since OnType just adds to the internal buffer
                                   of the Chentrah module.
                                   The zero scan code is the mouse movement message}
                    end;
              end;
            end;
          WM_KEYUP:
            begin
              f_HadMessages:= true;
              scancode:= DivineScanCode(msg); //угадать скан-код на кофейной гуще
              if (scancode < ord(KEY_MWHEEL_DOWN))
                and f_KeyState[scancode]
              then begin
                f_KeyState[scancode]:=false;
                CheckIfMouseMoved();
                OnRelease(scancode);
              end;
            end;
          WM_SYSKEYDOWN:
            begin
//              if Mother^.Debug.Verbose then AddLog('Window received WM_SYSKEYDOWN (%0, %1)', [msg.wparam, msg.lparam]);
              f_HadMessages:= true;
            end;
          WM_SYSKEYUP:
            begin
//              if Mother^.Debug.Verbose then AddLog('Window received WM_SYSKEYUP (%0, %1)', [msg.wparam, msg.lparam]);
              f_HadMessages:= true; ;
            end;
          WM_LBUTTONDOWN: begin
            f_HadMessages:= true;
            if not f_KeyState[ord(KEY_MOUSE_LEFT)] then begin
              f_KeyState[ord(KEY_MOUSE_LEFT)]:=true;
              CheckIfMouseMoved();
              OnPress(ord(KEY_MOUSE_LEFT));
            end;
          end;
          WM_LBUTTONUP: begin
            f_HadMessages:= true;
            if f_KeyState[ord(KEY_MOUSE_LEFT)] then begin
              f_KeyState[ord(KEY_MOUSE_LEFT)]:=false;
              CheckIfMouseMoved();
              OnRelease(ord(KEY_MOUSE_LEFT));
            end;
          end;
          WM_RBUTTONDOWN:
            if not f_KeyState[ord(KEY_MOUSE_RIGHT)] then begin
              f_KeyState[ord(KEY_MOUSE_RIGHT)]:=true;
              CheckIfMouseMoved();
              OnPress(ord(KEY_MOUSE_RIGHT));
            end;
          WM_RBUTTONUP: begin
            f_HadMessages:= true;
            if f_KeyState[ord(KEY_MOUSE_RIGHT)] then begin
              f_KeyState[ord(KEY_MOUSE_RIGHT)]:=false;
              CheckIfMouseMoved();
              OnRelease(ord(KEY_MOUSE_RIGHT));
            end;
          end;
          WM_MBUTTONDOWN: begin
            f_HadMessages:= true;
            if not f_KeyState[ord(KEY_MOUSE_MIDDLE)] then begin
              f_KeyState[ord(KEY_MOUSE_MIDDLE)]:=true;
              CheckIfMouseMoved();
              OnPress(ord(KEY_MOUSE_MIDDLE));
            end;
          end;
          WM_MBUTTONUP: begin
            f_HadMessages:= true;
            if f_KeyState[ord(KEY_MOUSE_MIDDLE)] then begin
              f_KeyState[ord(KEY_MOUSE_MIDDLE)]:=false;
              CheckIfMouseMoved();
              OnRelease(ord(KEY_MOUSE_MIDDLE));
            end;
          end;
          WM_MOUSEMOVE: begin
            // the mouse movement is custom-handled now
            //f_HadMessages:= true; //probably won't work correctly in Win 2k & XP
          end;
          WM_MOUSEWHEEL: begin
              f_HadMessages:= true;
              i:=smallint(HIWORD(msg.wParam)) div 120;
              while i > 0 do begin
                CheckIfMouseMoved();
                OnPress(ord(KEY_MWHEEL_UP));
                dec(i);
              end;
              while i < 0 do begin
                CheckIfMouseMoved();
                OnPress(ord(KEY_MWHEEL_DOWN));
                inc(i);
              end;
            end;
(*
          WM_SYSCOMMAND: begin
            case msg.wParam of

              SC_CLOSE: begin
                LogGoDownWM('WM_SYSCOMMAND + SC_CLOSE');
                Mother^.State.ExitRequested:= Yes;
              end;

              SC_MAXIMIZE: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SYSCOMMAND + SC_MAXIMIZE');
                f_maximized:= true;
                f_minimized:= false;
              end;
              SC_SCREENSAVE: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SYSCOMMAND + SC_SCREENSAVE');
                f_maximized:= false;
              end;
              SC_MINIMIZE: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SYSCOMMAND + SC_MINIMIZE');
                f_minimized:= true;
                f_maximized:= false;
                {  if Mother^.Display.InFullScreenMode then begin
                    LogGoDown(RuEn('окно потеряло фокус','the window lost focus'));
                    Mother^.State.ExitRequested:=true;
                  end;}
                end;
              SC_MONITORPOWER: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SYSCOMMAND + SC_MONITORPOWER');
                f_maximized:= false;
                {if msg.lParam > 0 then begin
                  LogGoDown(RuEn('монитор выключается или переходит в спящий режим','your monitor shuts down or goes to sleep'));
                  Mother^.State.ExitRequested:=true;
                end}
              end;
              SC_RESTORE: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SYSCOMMAND + SC_RESTORE');
                f_minimized:= false;
                f_maximized:= false;
              end;

            else
              if Mother^.Debug.Verbose then AddLog('Window received WM_SYSCOMMAND (wparam=%0, lparam=%1)', [intToHex(msg.wparam, 4), IntToHex(msg.lparam, 8)]);
            end;
          end;
*)
          WM_SIZE: begin
            case msg.wparam of
(*
              SIZE_MAXIMIZED: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SIZE + SIZE_MAXIMIZED');
                f_minimized:= false;
                f_maximized:= true;
              end;
*)
              SIZE_RESTORED: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SIZE + SIZE_RESTORED');
                f_HadMessages:= true;
//                  f_maximized:= false;
//                  f_minimized:= false;
//                UpdateWindowSize;
              end;
(*
              SIZE_MINIMIZED: begin
                if Mother^.Debug.Verbose then AddLog('Window received WM_SIZE + SIZE_MINIMIZED');
                f_minimized:= true;
                f_maximized:= false;
              end;
            else
              if Mother^.Debug.Verbose then AddLog('Window received WM_SIZE (wparam=%0, lparam=%1)', [intToHex(msg.wparam, 4), IntToHex(msg.lparam, 8)]);
*)
            end;
          end;
          WM_CLOSE:
            begin
              LogGoDownWM('WM_CLOSE');
              Mother^.State.ExitRequested:=true;
            end;
          WM_DESTROY:
            begin
              LogGoDownWM('WM_DESTROY');
              Mother^.State.ExitRequested:=true;
            end;
       //   $a0:;
       // else
       //   if Mother^.Debug.Verbose then AddLog('Window received: message=%0|%3, wparam=%1, lparam=%2', [IntToHex(msg.message, 4), IntToHex(msg.wparam, 4), IntToHex(msg.lparam, 8), msg.message]);
        end;
//AddLog('  message=%0|%3, wparam=%1, lparam=%2', [IntToHex(msg.message, 4), IntToHex(msg.wparam, 4), IntToHex(msg.lparam, 8), msg.message]);
        {if not msg.Message in [WM_QUIT, WM_CLOSE, WM_DESTROY] then} begin
          TranslateMessage(msg);
          DispatchMessage(msg);
        end;
      end;
//      end;
      if f_HadMessages then f_LoseFocusFramesCount:=0;

      if (f_state in [wsco_Normal, wsco_NoFocus])
        and (Mother^.State.OS = ostWine)
        and (gv_FramesSinceLeavingFullscreen < 3)
      then begin
        //The fuck...? I restore the window, then Wine suddenly moves it again,
        // to negative origin, so that the client area begins exactly at 0,0
        // and the window is overlapped with the XFCE taskbar
        cr:= ClipWindowToRect(Mother^.Display.WindowRect, Mother^.Display.ScreenRect);
        if (cr <> Mother^.Display.WindowRect) then begin
          if Mother^.Debug.Verbose then AddLog('Wine specific hack: our window happens to be outside the screen rect in less than 3 frames since leaving fullscreen. Correcting the window position.');
          if not MoveWindow(Mother^.Display.WindowHandle,cr.left, cr.top,cr.width,cr.height, false) then Die('MoveWindow() retuened false!');
        end;
      end;

      if f_state <> wsco_Maximized then inc(gv_FramesSinceLeavingFullscreen);
      if f_wsco <> f_state then begin
//addlog('*bp');
        case f_wsco of
          wsco_Maximized: begin
            Mother^.Display.InFullScreenMode:= true;
            GoFullscreen;
          end;
          wsco_Normal: begin
            case f_state of
              wsco_Maximized: begin
                Mother^.Display.InFullScreenMode:= false;
                LeaveFullScreen;
              end;
            end;
          end;
          wsco_NoFocus: begin
            case f_state of
              wsco_Maximized: begin
                Mother^.Display.InFullScreenMode:= false;
                LeaveFullScreen;
              end;
            end;
          end;
          wsco_Minimized: begin
            case f_state of
              wsco_Maximized: begin
                Mother^.Display.InFullScreenMode:= false;
                LeaveFullScreen;
              end;
            end;
          end;
        end;
        f_state:= f_wsco;
      end;
      NoteThreadOccupation(tlk_Working);
//addlog('* %0 %1',[ord(f_wsco), ord(f_state)]);
    end
    else begin // IsWindow(Mother^.Display.WindowHandle)
      LogGoDown(RuEn('окно приложения внезапно исчезло!','the application window has suddenly vanished!'));
      Mother^.Display.CanRender:= No;
      Mother^.Display.WindowExists:= No;
      Mother^.State.ExitRequested:= Yes;
    end;
  end;







