
//the same as un_filelist but with unicode support in Windows

//  http://msdn.microsoft.com/en-us/library/windows/desktop/aa365740%28v=vs.85%29.aspx
//  http://www.codeproject.com/Articles/21202/Reparse-Points-in-Vista

{$fatal NOTE TO SELF: IMPLEMENT THIS!}

unit un_filelist2;

interface
uses SysUtils, Classes, windows;

type
  PointerLikeArray = array of pointer;
  TPLAQSCompare = function(a, b: pointer): integer;

  procedure PLAQuickSort(var a: PointerLikeArray; CompareFn: TPLAQSCompare;  L: integer = 0; R: Integer = -1);

  type
    TFileList = class(TStringList)
    private
      SortedByDate: boolean;
      function _time(ind: integer): TDateTime;
      function _size(ind: integer): integer;
      function _attr(ind: integer): integer;
      function _sorted: boolean;
      function _msdostimestamp(index: integer): integer;
      procedure _setmsdostimestamp(index, value: integer);
      function _names(index: integer): string;
      function _only_name(index: integer): string;
    public
      constructor Create(pathmask: string); virtual; overload;
      constructor Create(pathmask: string; attr: longint); overload;
      procedure SortByName;
      procedure Sort; OVERRIDE;
      procedure SortByDate; //default
      procedure Merge(MergeTo: TFileList); //calls free
      destructor Destroy; Override;
      procedure SetName(c: integer; s: string);
      function IndexOf(s: string): integer;
      Property Time[index: integer]: TDateTime read _time;
      property MSDOSTimeStamp[index: integer]: integer read _msdostimestamp write _setmsdostimestamp;
      Property Size[index: integer]: integer read _size;
      Property Attributes[index: integer]: integer read _attr;
      Property Sorted: boolean read _sorted;
      Property Names[index: integer]: string read _names write SetName;
      property OnlyName[index: integer]: string read _only_name;
    end;

    TDirectoryList = class; //forward declaration

    TDirectory = class
      Constructor Create(path: string);
      Destructor Destroy; Override;
    private
      _files: TFileList;
      _dirs: TDirectoryList;
      _name, _path: string;
    public
      property Files: TFileList read _files;
      property Directories: TDirectoryList read _dirs;
      property Name: string read _name;
      property Path: string read _path;
    end;

    TDirectoryList = class(TStringList)
    private
      function _d(ind: integer): TDirectory;
    public
      constructor Create (path: string);
      destructor Destroy; Override;
      property Dir[index: integer]:TDirectory read _d;
    end;

    { TFullFileList }

    TFullFileList = class(TFileList)
    protected
      FBasePath: string;
  //    function _relnames(index: integer): string;
    public
      constructor Create(path: string); override;
  //    Property RelativeNames[index: integer]: string read _relnames;
    end;

implementation

  //ripped from FPC RTL

  procedure PLAQuickSort(var a: PointerLikeArray; CompareFn: TPLAQSCompare;  L, R: Integer);
  var
    Pivot, vL, vR: Integer;
    tp: pointer;
  begin
    if not Assigned(a) then Exit;
    if R < 0 then R:= High(a);
    if R - L <= 1 then begin // a little bit of time saver
      if L < R then
        if CompareFn(a[L], a[R]) > 0 then begin
          tp:= a[R];
          a[R]:= a[L];
          a[L]:= tp;
        end;

      Exit;
    end;

    vL := L;
    vR := R;

    Pivot := L + Random(R - L); // they say random is best

    while vL < vR do begin
      while (vL < Pivot) and (CompareFn(a[vL], a[Pivot]) <= 0) do
        Inc(vL);

      while (vR > Pivot) and (CompareFn(a[vR], a[Pivot]) > 0) do
        Dec(vR);

      tp:= a[vR];
      a[vR]:= a[vL];
      a[vL]:= tp;

      if Pivot = vL then // swap pivot if we just hit it from one side
        Pivot := vR
      else if Pivot = vR then
        Pivot := vL;
    end;

    if Pivot - 1 >= L then
      PLAQuickSort(a, CompareFn, L, Pivot - 1);
    if Pivot + 1 <= R then
      PLAQuickSort(a, CompareFn, Pivot + 1, R);
  end;


end.

