procedure EnterCriticalSectionWv(var cs: TRtlCriticalSection); inline;
var
  oto: TThreadLoadKind;
begin
  oto:= NoteThreadOccupation(tlk_WaitingSync);
  EnterCriticalSection(cs);
  NoteThreadOccupation(oto);
end;

  procedure EnterWv(cs: TCriticalSection; CountLoadAs: TThreadLoadKind = tlk_WaitingSync); inline;
var
  oto: TThreadLoadKind;
begin
  oto:= NoteThreadOccupation(CountLoadAs);
  cs.Enter;
  NoteThreadOccupation(oto);
end;

function NoteThreadOccupation(o: TThreadLoadKind): TThreadLoadKind;
var
  pes: PMotherSehState;
begin
  if not Assigned(Mother) or not Mother^.Safe then Exit(tlk_Working);
  pes:= GetExceptionStateIfExists();
  if not Assigned(pes) then Exit(tlk_Working);
  {
    Assembly here is not only for the TSC but also to allow integer overflow
    when the range checking is on
  }
  asm
    {$ifdef cpu64}
      push rax
      push rdx
      push rsi
      push rcx
      pushf
      mov rsi, [pes]
      mov rcx, qword[rsi + TMotherSEHState.tlitsc]
      mov eax, 0
      rdtsc
      mov dword[rsi + TMotherSEHState.tlitsc], eax;
      mov dword[rsi + 4 + TMotherSEHState.tlitsc], edx;
      shl rdx, 32
      add rdx, rax
      sub rdx, rcx
      mov rcx, 0
      mov ecx, dword[rsi + TMotherSEHState.tlic]
      add qword[rsi + rcx * 8 + TMotherSEHState.tli], rdx
      popf
      pop rcx
      pop rsi
      pop rdx
      pop rax
    {$else}
      push eax
      push edx
      push esi
      push ecx
      push edi
      pushf
      mov esi, [pes]
      mov ecx, dword[esi + TMotherSEHState.tlitsc]
      mov edi, dword[esi + 4 + TMotherSEHState.tlitsc]
      rdtsc
      mov dword[esi + TMotherSEHState.tlitsc], eax;
      mov dword[esi + 4 + TMotherSEHState.tlitsc], edx;
      sub eax, ecx
      sbb edx, edi
      mov ecx, dword[esi + TMotherSEHState.tlic]
      add dword[esi + ecx * 8 + TMotherSEHState.tli], eax
      adc dword[esi + ecx * 8 + 4 + TMotherSEHState.tli], edx
      popf
      pop edi
      pop ecx
      pop esi
      pop edx
      pop eax
    {$endif}
  end;
  Result:= pes^.tlic;
  pes^.tlic:= o;
end;

function GetExceptionStateIfExists(): PMotherSehState;
var
  pes: PMotherSehState;
  T: TThreadId;
begin
  Result:= pesThreadVar;
  if not Assigned(Result) then begin
    T:= GetCurrentThreadId();
    pes:= @Mother^.ExceptionState;
    while Assigned(pes) do begin
      if T = pes^.ThreadId then begin
        Result:= pes;
        break;
      end;
      pes:= pes^.Next;
    end;
    pesThreadVar:= Result;
  end;
end;

